#include "property_variable_callback_filter.h"

// The code behind the macro creates a plugin and the main entries to the plugin DLL or shared object.
// The cPropertyFilter will be available through the plugins class factory.
ADTF_PLUGIN("Property Variable Callback Filter Plugin",
            cPropertyVariableCallbackFilter);

cPropertyVariableCallbackFilter::cPropertyVariableCallbackFilter()
{
    // Let's register the property_variable
    m_oObservedProperty.SetDescription("Property to observe.");
    RegisterPropertyVariable("observed_property", m_oObservedProperty);

    // Now add the callback to the property_variable and listen to changes
    // To access the property in the lambda function let's capture the filter pointer
    m_oObservedProperty.SetPropertyChangedCallback([this]()
    {
        LOG_INFO("Property observed_property has been changed to '%f'", *m_oObservedProperty);
    }); 

    // set basic information about the component itself and purpose
    SetDescription("This filter shows the usage of callbacks regarding property changes.");
}